/*
    Project: TCTEMP
    Version: V1.22
    File   : rtl_w2k.c

    Copyright (c) 2006-2012 Author of TCTEMP. All rights reserved.
    Public Key Fingerprint: 75EB 6BC2 01B7 F6E7 4BD7 CC58 4A5F C393 19EE 6E69

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCTEMP binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#define NA_NO_DEBUG
#include "na_priv.h"

#if WINVER <= 0x0500

int _cdecl _vsnwprintf(wchar_t *pwszBuffer, size_t cchBuffer,
  const wchar_t *pcwszFormat, va_list va)
{
    PSTR   pasz;
    PSTR   paszFormatEnd;
    BOOL   fConvert;
    int    iResult;
    int    i;

    fConvert = FALSE;
    pasz = g_pi.ppi->aszVsnwprintfBuffer;
    paszFormatEnd = pasz + sizeof(g_pi.ppi->aszVsnwprintfBuffer);

    while (*pcwszFormat && pasz != paszFormatEnd) {
        if (fConvert) {
            switch(*pcwszFormat) {
            case L'c':
                *pasz = 'C';
                break;
            case L'C':
                *pasz = 'c';
                break;
            case L's':
                *pasz = 'S';
                break;
            case L'S':
                *pasz = 's';
                break;
            default:
                *pasz = (CHAR) *pcwszFormat;
            }
            fConvert = FALSE;
        } else {
            if (*pcwszFormat == L'%') fConvert = TRUE;
            *pasz = (CHAR) *pcwszFormat;
        }
        pasz++;
        pcwszFormat++;
    }
    if (pasz == paszFormatEnd) {
        *pwszBuffer = L'\0';
        return -1;
    }
    *pasz = '\0';

    iResult = _vsnprintf((PSTR)pwszBuffer, cchBuffer,
      g_pi.ppi->aszVsnwprintfBuffer, va);
    if (iResult < 0 || ((SIZE_T) iResult) >= cchBuffer) {
        *pwszBuffer = L'\0';
        return -1;
    }

    pasz = (PSTR)pwszBuffer;
    for (i = iResult; i--; ) {
        pwszBuffer[i] = (WCHAR)pasz[i];
    }
    pwszBuffer[iResult] = L'\0';

    return iResult;
}

#  ifdef KMDF_MAJOR_VERSION /* Windows Driver Kit */

long __stdcall RtlUnhandledExceptionFilter(void *p)
{
    return 0;
}

#  else /* Windows DDK */

long __stdcall _imp__RtlUnhandledExceptionFilter(void *p)
{
    return 0;
}

extern void NTAPI NtProcessStartup(PVOID);

void NtProcessStartupForGS(PVOID p)
{
    NtProcessStartup(p);
}

extern long _cdecl _ftol(double);
long _cdecl _ftol2(double d)
{
    return _ftol(d);
}

#  endif

#endif
